# -*- coding: utf-8 -*-
## 
## Copyright (C)2005 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

"""
$Id: Install.py,v 1.18 2006/10/31 11:53:39 b_mathieu Exp $
"""
__docformat__ = 'restructuredtext'



__author__  = ''

# Python imports
from StringIO import StringIO

# Zope imports

# CMF imports
from Products.CMFCore.utils import getToolByName

# Archetypes imports
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin

# Products imports
from Products.PloneExFile.config import PROJECTNAME, GLOBALS, SKINS_DIR

def install(self):
    out = StringIO()
    
    # Install types
    typeInfo = listTypes(PROJECTNAME)
    installTypes(self, out, typeInfo, PROJECTNAME)

    # Install skin
    install_subskin(self, out, GLOBALS)
        
    # Install properties
    ptool = getToolByName(self, 'portal_properties')
    
    # Create property sheets
    if not hasattr(ptool, 'ploneexfile_properties'):
        ptool.addPropertySheet('ploneexfile_properties',
                               'PloneExFile properties')
    
    # Set exfile not downloaded in listings
    propsTool = getToolByName(self, 'portal_properties')
    siteProperties = getattr(propsTool, 'site_properties')
    typesUseViewActionInListings = list(
        siteProperties.getProperty('typesUseViewActionInListings')
        )
    
    if 'PloneExFile' not in typesUseViewActionInListings:
        typesUseViewActionInListings.append('PloneExFile')
        siteProperties.manage_changeProperties(
            typesUseViewActionInListings=typesUseViewActionInListings
            )
        print >> out, "Added 'PloneExFile' to portal_properties.typesUseViewActionInListings"

    # Add action icons
    print >> out, "Add action icons for 'lock', 'unlock'"
    addActionIcon(self, category='plone', action_id='lock',
                  icon_expr='lock.gif', title="Lock (Currently not locked)",
                  priority=0)
    addActionIcon(self, category='plone', action_id='unlock',
                  icon_expr='unlock.gif', title="Unlock (Currently locked)",
                  priority=0)
    
    print >> out, 'Installation completed.'
    return out.getvalue()

def uninstall(self):
    out = StringIO()

    # Unset properties
    propsTool = getToolByName(self, 'portal_properties')
    siteProperties = getattr(propsTool, 'site_properties')
    typesUseViewActionInListings = list(siteProperties.getProperty('typesUseViewActionInListings'))
    if 'PloneExFile' in typesUseViewActionInListings:
        typesUseViewActionInListings = [t for t in typesUseViewActionInListings if t != 'PloneExFile']
        siteProperties.manage_changeProperties(typesUseViewActionInListings=typesUseViewActionInListings)
        print >> out, "Removed 'PloneExFile' to portal_properties.typesUseViewActionInListings"
    
    print >> out, 'Uninstallation completed.'
    return out.getvalue()

def addActionIcon(self, category, action_id, icon_expr, title=None, priority=0):
    # Add the action icon if and only if it's not already here
    ai=getToolByName(self, 'portal_actionicons')
    if ai.queryActionInfo( category, action_id ):
      ai.updateActionIcon(category, action_id, icon_expr, title, priority)
    else:
      ai.addActionIcon(category, action_id, icon_expr, title, priority)
