# -*- coding: utf-8 -*-
## Product description
## 
## Copyright (C) 2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
from StringIO import StringIO
from time import time
from Acquisition import aq_base
from Products.CMFCore.utils import getToolByName

def migrate_v3_v4(self):
    """
    Migrate ExFiles from v3 to v4
    
    Ensure you portal_catalog is up to date! i.e. you must have all of your
    content catalogged, else some ExFiles could be missed.
    """
    out = StringIO()
    
    pt = getToolByName(self, 'portal_types')
    fti = pt['PloneExFile']
    allowed_views = dict.fromkeys(fti.getAvailableViewMethods(self), True)

    del_attrs = ('_lock_history', '_locked_by', '_unlocked_by',
                 '_unlocked_date', '_locked_date')

    cat = getToolByName(self, 'portal_catalog')
    brains = cat(portal_type="PloneExFile")
    marker = "plonexfile_migrator_%s" % str(time())
    
    for b in brains:
        print >> out, b.getPath(), ":",
        migrated = False
        wrapped = b.getObject()
        o = aq_base(wrapped)
        
        for a in del_attrs:
            if getattr(o, a, marker) != marker:
                migrated = True
                delattr(o, a)

        # old objects have layout=ExFile_view, which is wrong
        # this resets to the default view
        layout = getattr(o, 'layout', None)
        if layout and not allowed_views.has_key(layout):
            migrated = True
            print >> out, "bad view method: %s, fixed," % layout,
            delattr(o, 'layout')

        if not migrated:
            print >> out, "...nothing to do."
        else:
            print >> out, "...done."

    return out.getvalue()
