# -*- coding: utf-8 -*-
## 
## Copyright (C)2005 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

"""
$Id: __init__.py,v 1.8 2006/10/31 11:53:38 b_mathieu Exp $
"""
__docformat__ = 'restructuredtext'



__author__  = ''

import sys

from Globals import package_home
from Products.CMFCore import utils
from Products.CMFCore.permissions import ManagePortal
from Products.CMFCore.DirectoryView import registerDirectory

from Products.Archetypes.atapi import process_types, listTypes

from Products.PloneExFile.config import SKINS_DIR, GLOBALS, PROJECTNAME
from Products.PloneExFile import Permissions
from Products.PloneExFile.fti import TTWLockableFTI, ExFileFTI, \
     manage_addTTWFTIForm, manage_addExFileFTIForm

import logging
LOG = logging.getLogger(PROJECTNAME)

registerDirectory(SKINS_DIR, GLOBALS)

def initialize(context):

    # register ftis
    context.registerClass(TTWLockableFTI,
                          permission=ManagePortal,
                          constructors=(manage_addTTWFTIForm,),
                          visibility=None)
    context.registerClass(ExFileFTI,
                          permission=ManagePortal,
                          constructors=(manage_addExFileFTIForm,),
                          visibility=None)
    
    # Import types
    from Products.PloneExFile import ExFile

    content_types, constructors, ftis = process_types(
            listTypes(PROJECTNAME),
            PROJECTNAME)

    utils.ContentInit(
        '%s Content' % PROJECTNAME,
        content_types      = content_types,
        permission         = Permissions.AddExFile,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)
